;ͻ
;         (C) Copyright:       Freie Cracker Crew Hamburg Horn              
;                                                                           
;                   von:             Dirk Wolfgang Glomp                    
;ͼ
.MODEL SMALL
.386
;
Max_Seite  =  8
Max_Zeile  = 50
Max_Spalte = 80
;
  CODE SEGMENT use16 'CODE'
 assume cs:CODE,ds:DATEN,ss:STAPEL
;----------------------------------------------------------------------------
START:    mov     ax, DATEN
          mov     ds, ax
          mov     di, OFFSET SEITE
          mov     es, ax
;
          mov     ah, 62h            ; Segment des PSP's ermitteln
          int   21h
          cli                        ; IRQs verbieten
          mov     ds, bx             ; PSP-Segment nach DS
          mov     si, 80h            ; Zeiger auf Parameter-Anzahl
          mov     al, [si]           ; Anzahl holen
          cmp     al, 6              ;  weniger als  6 ASCII's ?
          jb  short FEHLER1          ; zu wenig = Fehler !
          cmp     al, 0Dh            ;  mehr    als 13 ASCII's ?
          ja  short FEHLER2          ; zu viel  = Fehler !
          add     si, 2              ; Zeiger auf 1. Parameter
;
; max. 2 Ziffer je Parameter wandeln, Daten-Byte 0 bis 99 retten
;
          mov     cl, 3              ; drei Parameter
;------------------------------------
HOLWERT:  mov     ax, [si]           ; zwei ASCII's holen
          sub     al, 30h            ; 1. ASCII nach Integer wandeln
          cmp     al, 9              ;  1. Wert grer als neun ?
          ja  short FEHLER3          ; keine Ziffer = Fehler !
          add     si, 2              ; Zeiger erhhen
          cmp     ah, 0Dh            ;  Parameter-Ende erreicht ?
          jz  short ANTEIL
          cmp     ah, ","            ;  nur eine Ziffer ?
          jz  short ANTEIL
          sub     ah, 30h            ; 2. ASCII nach Integer wandeln
          cmp     ah, 9              ;  2. Wert grer als neun ?
          ja  short FEHLER3          ; keine Ziffer = Fehler !
;------------------------------------
          mov     bl, al             ; nach zweistelligen Integer wandeln
          shl     al, 3              ; Wert mal 8
          add     bl, bl             ; Wert mal 2
          add     al, bl             ;            = Wert mal 10
          add     al, ah             ; Einer dazu
          inc     si                 ; Komma berspringen
;------------------------------------
ANTEIL:   mov     es:[di], al        ; Wert retten
          inc     di
          dec     cl
          jnz HOLWERT
;----------------------------------------------------------------------------
          mov     ax, DATEN
          mov     ds, ax
;------------------------------------
          mov     bh, SEITE
          cmp     bh, Max_Seite
          ja  short FEHLER4          ; Wert zu hoch = Fehler !
          mov     dh, Zeile
          cmp     dh, Max_Zeile
          ja  short FEHLER5          ; Wert zu hoch = Fehler !
          mov     dl, Spalte
          cmp     dl, Max_Spalte
          ja  short FEHLER6          ; Wert zu hoch = Fehler !
          mov     ah, 2              ; Cursor setzen
          int   10h
;
          xor     al, al             ; kein Fehler
;------------------------------------
DOS:      mov     ah, 4Ch            ; Dos-Rcksprung
          sti                        ; IRQs erlauben
          int   21h
;
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER1:  call BASIS
          mov     al, 1              ; ERRORLEVEL = 1
          mov     dx, OFFSET ERRCO1
;------------------------------------
WORK:     mov     ah, 9              ; Text ausgeben
          int   21h
          jmp  short DOS
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER2:  call BASIS
          mov     al, 2              ; ERRORLEVEL = 2
          mov     dx, OFFSET ERRCO2
          jmp  short WORK
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER3:  call BASIS
          mov     al, 3              ; ERRORLEVEL = 3
          mov     dx, OFFSET ERRCO3
          jmp  short WORK
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER4:  call BASIS
          mov     al, 4              ; ERRORLEVEL = 4
          mov     dx, OFFSET ERRCO4
          jmp  short WORK
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER5:  call BASIS
          mov     al, 5              ; ERRORLEVEL = 5
          mov     dx, OFFSET ERRCO5
          jmp  short WORK
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER6:  call BASIS
          mov     al, 6              ; ERRORLEVEL = 6
          mov     dx, OFFSET ERRCO6
          jmp  short WORK
;
;                        U n t e r  -  P r o g r a m m e
;
 org START + ((($-START)/16)*16)+16  ; Code-Alignment
;----------------------------------------------------------------------------
BASIS:    mov     ax, DATEN
          mov     ds, ax
          mov     dx, OFFSET SYNTAX
          mov     ah, 9
          int   21h
          ret
;----------------------------------------------------------------------------
  CODE ends
;
;                          D A T E N - B E R E I C H
;
  DATEN SEGMENT use32 'DATA'         ; Daten-Alignment
;----------------------------------------------------------------------------
SEITE     DB ?
ZEILE     DB ?
SPALTE    DB ?
;----------------------------------------------------------------------------
SYNTAX    DB 0Dh, 0Ah
DB "ͻ"
DB "                                                                              "
DB "           SYNTAX:            CURSOR.exe Seite,Zeile,Spalte                   "
DB "                                                                              "
DB "                                  Seite :   0   bis    8                      "
DB "                                                                              "
DB "                                  Zeile :   1   bis   50                      "
DB "     Version  1.0                                                             "
DB "                                  Spalte:   1   bis   80                      "
DB "                                                                              "
DB "    (C) Copyright:           Freie Cracker Crew Hamburg Horn                  "
DB "                                                                              "
DB "              von:                 Dirk Wolfgang Glomp                        "
DB "                                                                              "
DB "ͼ"
DB 0Dh, 0Ah ,"$"
;----------------------------------------------------------------------------
ERRCO1    DB "                   zu wenige Parameter angegeben = Fehler !"
          DB 7, "$"
ERRCO2    DB "                   zu viele Parameter angegeben = Fehler !"
          DB 7, "$"
ERRCO3    DB "                   keine Ziffer = Fehler !"
          DB 7, "$"
ERRCO4    DB "                   Seite zu hoch = Fehler !"
          DB 7, "$"
ERRCO5    DB "                   Zeile zu hoch = Fehler !"
          DB 7, "$"
ERRCO6    DB "                   Spalte zu hoch = Fehler !"
          DB 7, "$"
;----------------------------------------------------------------------------
  DATEN ends
;
  STAPEL SEGMENT use16 STACK 'STACK'
          DB 10h dup (?)
  STAPEL ends
;
 end
