;ͻ
;         (C) Copyright:  Freie Cracker Crew Hamburg Horn                   
;                                                                           
;                   von:           Dirk Wolfgang Glomp                      
;ͼ
.MODEL SMALL
.386
;
  CODE SEGMENT use16 'CODE'
 assume cs:CODE,ds:DATEN,ss:STAPEL
;----------------------------------------------------------------------------
START:    mov     ax, DATEN
          mov     ds, ax
          mov     es, ax
;
          mov     ah, 62h             ; Segment des PSP's ermitteln
          int   21h
          cli                         ; IRQs verbieten
          mov     ds, bx              ; PSP-Segment nach DS
          mov     si, 80h             ; Zeiger auf Parameter
          mov     al, [si]
          cmp     al, 1               ;  weniger als 1 ASCII   ?
          jb  short FEHLER1           ; zu wenig = Fehler !
          cmp     al, 4               ;  mehr    als 4 ASCII's ?
          ja  FEHLER2                 ; zu viel  = Fehler !
          add     si, 2
;
          mov     ax, [si]            ; zwei ASCII's holen
          add     si, 2               ; Zeiger erhhen
          sub     al, 30h             ; 1. ASCII nach Integer wandeln
          cmp     al, 9               ;  1. Wert grer als neun ?
          ja  FEHLER3                 ; keine Ziffer = Fehler !
          cmp     ah, ","             ;  schon Komma, nur eine Ziffer ?
          jz  short HUNDERT
          cmp     ah, 0Dh             ;  schon Param.-Ende, nur eine Ziffer ?
          jz  short HUNDERT
          sub     ah, 30h             ; 2. ASCII nach Integer wandeln
          cmp     ah, 9               ;  2. Wert grer als neun ?
          ja  short FEHLER3           ; keine Ziffer = Fehler !
;-------------------------------------
          mov     bl, al              ; 1. Ziffer mal 10
          shl     al, 3               ; Wert mal 8
          add     bl, bl              ; Wert mal 2
          add     al, bl              ; Zehner          = Wert mal 10
;-------------------------------------
          xor     dh, dh
          mov     dl, [si]            ; dritten ASCII holen
          cmp     dl, ","             ;  schon Komma, nur zwei Ziffern ?
          jz  short ZEHNER
          cmp     dl, 0Dh             ;  schon Param.-Ende, nur zwei Ziffern ?
          jz  short ZEHNER
          sub     dl, 30h             ; 3. ASCII nach Integer wandeln
          cmp     dl, 9               ;  3. Wert grer als neun ?
          ja  short FEHLER3           ; keine Ziffer = Fehler !
          inc     si                  ; Zeiger erhhen
;-------------------------------------
          mov     cx, ax
          xor     ch, ch
          mov     bx, cx              ; 1. Ziffer noch einmal mal 10
          shl     cx, 3               ; Wert mal 8
          add     bx, bx              ; Wert mal 2
          add     cx, bx              ; jetzt Hunderter = Wert mal 100
;-------------------------------------
          mov     al, ah              ; 2. Ziffer mal 10
          shl     ah, 3               ; Wert mal 8
          add     al, al              ; Wert mal 2
          add     al, ah              ; jetzt Zehner    = Wert mal 10
          xor     ah, ah
          add     ax, cx              ; Zehner plus Hunderter
          add     ax, dx              ; Einer dazu
          inc     si                  ; Komma berspringen
          jmp  short HUNDERT
;-------------------------------------
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;-------------------------------------
ZEHNER:   add     al, ah              ; Einer/Zehner dazu
;-------------------------------------
HUNDERT:  xor     ah, ah
          int   10h                   ; Video-Mode setzen
;
          xor     al, al              ; kein Fehler
;-------------------------------------
DOS:      mov     ah, 4Ch             ; Dos-Rcksprung
          sti                         ; IRQs erlauben
          int   21h
;
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER1:  call BASIS
          mov     al, 1               ; ERRORLEVEL = 1
          mov     dx, OFFSET ERRCO1
;-------------------------------------
WORK:     mov     ah, 9               ; Text ausgeben
          int   21h
          jmp  short DOS
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER2:  call BASIS
          mov     al, 2               ; ERRORLEVEL = 2
          mov     dx, OFFSET ERRCO2
          jmp  short WORK
;----------------------------------------------------------------------------
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
FEHLER3:  call BASIS
          mov     al, 3               ; ERRORLEVEL = 3
          mov     dx, OFFSET ERRCO3
          jmp  short WORK
;
;                        U n t e r  -  P r o g r a m m e
;
 org START + ((($-START)/16)*16)+16   ; Code-Alignment
;----------------------------------------------------------------------------
BASIS:    mov     ax, DATEN
          mov     ds, ax
          mov     dx, OFFSET SYNTAX
          mov     ah, 9
          int   21h
          ret
;----------------------------------------------------------------------------
  CODE ends
;
;                          D A T E N - B E R E I C H
;
  DATEN SEGMENT use32 'DATA'          ; Daten-Alignment
;----------------------------------------------------------------------------
SYNTAX    DB 0Dh, 0Ah
DB "ͻ"
DB "                                                                              "
DB "           SYNTAX:                SETMODE.exe Video-Mode  (0 bis 255)         "
DB "                                                                              "
DB " Mode  Auflsung  Farben  Bemerkung  Mode  Auflsung  Farben  Bemerkung "
DB "    "
DB "   0     40x25      16      Text      13    320x200     16     Grafik   "
DB "   1     40x25      16      Text      14    640x200     16     Grafik   "
DB "   2     80x25      16      Text      15    640x350    mono    Grafik   "
DB "   3     80x25      16      Text      16    640x350     16     Grafik   "
DB "   4    320x200      4     Grafik     17    640x480    mono    Grafik   "
DB "   5    320x200      4     Grafik     18    640x480     16     Grafik   "
DB "   6    640x200      2     Grafik     19    320x200    256     Grafik   "
DB "   7     80x25     mono     Text                                           "
DB "                                                                              "
DB "                        auch alle anderen Video-Modi sind erlaubt             "
DB "                                                                              "
DB "    (C) Copyright:           Freie Cracker Crew Hamburg Horn                  "
DB "                                                                Version  1.0  "
DB "              von:                 Dirk Wolfgang Glomp                        "
DB "                                                                              "
DB "ͼ"
DB 0Dh, 0Ah ,"$"
;----------------------------------------------------------------------------
ERRCO1    DB "                   zu wenige Parameter angegeben = Fehler !"
          DB 7, "$"
ERRCO2    DB "                   zu viele Parameter angegeben = Fehler !"
          DB 7, "$"
ERRCO3    DB "                   keine dezimale Ziffer = Fehler !"
          DB 7, "$"
;----------------------------------------------------------------------------
  DATEN ends
;
  STAPEL SEGMENT use16 STACK 'STACK'
          DB 10h dup (?)
  STAPEL ends
;
 end
